#<profile4xi profile = "02" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "semaphore4xi.py">
#<abstract4xi abstract = "provides Semaphore4Xi class"/>
#<refer4xi reference = "synchronize.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Semaphore4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread
    import _winapi
       
except:
    pass
try:                 # most-common ones
    pass         
except:
    pass
try:                 # rare ones
    pass          
except:
    pass 
try:                 # imported-as ones 
    from time import time as _time, sleep as _sleep     
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>



# -------------------------------------------------------------------------------------------------
# DragonXi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi

import constant_family4xi
from constant_synchronize4xi import ConstantSynchronize4Xi
from constant_synchronize4xi import get_semaphore_synchronize4xi
from constant_synchronize4xi import get_sem_value_max_synchronize4xi
from reason_object4xi import reason_object4xi
from register_after_fork4xi import register_after_fork4xi

from semlock4xi import SemLock4Xi
from sense_object4xi import sense_object4xi

from _cleanup4xi import _cleanup4xi
from _exit_function4xi import _exit_function4xi
from _run_after_forkers4xi import _run_after_forkers4xi 

from print4xi import print4xi
from time4xi import time4xi
#"
#/>

        
# =================================================================================================
#<class4xi class = "Semaphore4Xi" base = "SemLock4Xi" child = "None" 
#  synopsis = "Semaphore services"
#  usage = "
#     forking4xi.py:
#         self._wait_semaphore = Semaphore(0)
#
#     condition4xi.py:
#         self._sleeping_count = Semaphore4Xi(0)
#
#     joinablequeue4xi.py:
#         self._unfinished_tasks = Semaphore4Xi(0)
#     syncmanager4xi.py:
#         SyncManager4Xi.register('Semaphore4Xi', threading.Semaphore, AcquirerProxy4Xi)
#     __init__.py:
#         return Semaphore4Xi(value)
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class Semaphore4Xi(SemLock4Xi):
    '''
    Semaphore services
    ''' 
    
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('get_value',
                 'sense', 'reason', 'ace')          
    #"
    #/>
                                                                                                                                                                    
                                                                                                                                                           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Semaphore4Xi" usage = "initializes Semaphore4Xi">                         
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self, semaphore=get_semaphore_synchronize4xi(), value=1, maxvalue=get_sem_value_max_synchronize4xi()):
        '''
        initializes Semaphore4Xi 
        '''
        class2print = "Semaphore4Xi"
        method2print = "__init__"
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)                               
        # -----------------------------------------------------------------------------------------           
        message2print = "{(Step 1/3a) started" + "; init-of-Semaphore4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                        
        message2print = "{(Step 1/3b) borning" + "; semaphore2xi-of-Semaphore4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        message2print = "{(Step 1/3c) inheriting" + "; SemLock4Xi-inheriting-by-semaphore2xi-of-Semaphore4Xi: " + str(SemLock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                                
        message2print = "{(Step 1/3d) passed" + "; semaphore-passed-to-init-of-Semaphore4Xi: " + str(semaphore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
                
        message2print = "{(Step 1/3e) passed" + "; value-passed-to-init-of-Semaphore4Xi: " + str(value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
                
        message2print = "{(Step 1/3f) passed" + "; maxvalue-passed-to-init-of-Semaphore4Xi: " + str(maxvalue) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
                                                                                                         
        # -----------------------------------------------------------------------------------------    
        # (Step 2/3) 
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 2/3a) passing" + "; semlock2xi-passing-to-SemLock4Xi-init-by-init-of-Semaphore4Xi: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3b) passing" + "; semaphore-passing-to-SemLock4Xi-init-by-init-of-Semaphore4Xi: " + str(semaphore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c) passing" + "; value-passing-to-SemLock4Xi-init-by-init-of-Semaphore4Xi: " + str(value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3d) passing" + "; maxvalue-passing-to-SemLock4Xi-init-by-init-of-Semaphore4Xi: " + str(maxvalue) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                              
                       
        SemLock4Xi.__init__(self, semaphore, value, maxvalue) #dragonized (self, SEMAPHORE, value, SEM_VALUE_MAX)  
        
        message2print = "{(Step 2/3e) performed" + "; SemLock4Xi-init-performed-by-init-of-Semaphore4Xi: " + str(SemLock4Xi.__init__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                  
        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3) 
        # -----------------------------------------------------------------------------------------                 
        
        message2print = "{(Step 3/3a) inherited" + "; SemLock4Xi-inherited-by-semaphore2xi-of-Semaphore4Xi: " + str(SemLock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
           
        
        message2print = "{(Step 3/3b) activated" + "; semaphore2xi-of-Semaphore4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                        
        message2print = "{(Step 3/3c) returning" + "; init-of-Semaphore4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
               
                          
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-value-of-Semaphore4Xi" usage = "returns value with (self)">                        
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def get_value(self):
        '''
        Semaphore4Xi method get_value: returns value with (self)
        '''
        class2print = "Semaphore4Xi"
        method2print = "get_value"
        
        message2print = "{started" + "; get-value-of-Semaphore4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
           
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        message2print = "{returning" + "; semlock-get-value-function-returning-by-get-value-of-Semaphore4Xi: " + str(self._semlock._get_value) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                                     
        
        return self._semlock._get_value() # self._semlock is set by SemLock4Xi.__init__  
    #</methodize4xi>
                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-Semaphore4X" usage = "reprs with (self) ">                         
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __repr__(self):
        '''
        Semaphore4Xi method __repr__: reprs with (self) 
        '''
        
        # -----------------------------------------------------------------------------------------    
        # (Step 1/3)
        # -----------------------------------------------------------------------------------------                 
           
        class2print = "Semaphore4Xi"
        method2print = "__repr__"
        
        message2print = "{(Step 1/3) started" + "; repr-of-Semaphore4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
       
        
        # -----------------------------------------------------------------------------------------    
        # (Step 2/3)
        # -----------------------------------------------------------------------------------------                 
        
        try:
            value2xi = self._semlock._get_value()
            
            message2print = "{(Step 2/3a) set" + "; value2xi-set-by-repr-of-Semaphore4Xi to: " + str(value2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    

        except Exception:
            value2xi = 'unknown'
            
            message2print = "{(Step 2/3b) set" + "; value2xi-set-by-repr-of-Semaphore4Xi to: " + str(value2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            
            message2print = "{(Step 2/3c) hit" + "; exception-hit-by-repr-of-Semaphore4Xi: " + " *** unknown value got for semaphore lock from function: " + str(self._semlock._get_value) + "  *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                    
                
                     
        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 3/3) returning" + "; value2xi-returning-by-repr-of-Semaphore4Xi: " + str(value2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                    
            
        return '<Semaphore4Xi(value2xi=%s)>' % value2xi  
    #</methodize4xi>
             
              
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Semaphore4Xi" usage = "senses Semaphore4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses Semaphore4Xi class objects
        '''
   
        
        class2print = 'Semaphore4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-Semaphore4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; Semaphore4Xi-sensing-by-sense-of-Semaphore4Xi: " + str(Semaphore4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                     
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-Semaphore4Xi to: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['semlock-of-semaphore2xi'] = str(self._semlock)     
            kb2xi['value-of-semaphore2xi'] = self._semlock._get_value()        
            
          
            message2print = "{sensed" + "; Semaphore4Xi-sensed-by-sense-of-Semaphore4Xi: " + str(Semaphore4Xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)         
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-Semaphore4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 

        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-Semaphore4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Semaphore4Xi" usage = "reasons Semaphore4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons Semaphore4Xi class objects
        '''
 
        
        class2print = 'Semaphore4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-Semaphore4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; Semaphore4Xi-reasoning-by-reason-of-Semaphore4Xi: " + str(Semaphore4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-Semaphore4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------          

        
          
        
        message2print = "{reasoned" + "; Semaphore4Xi-reasoned-by-reason-of-Semaphore4Xi: " + str(Semaphore4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-Semaphore4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Semaphore4Xi" usage = "aces Semaphore4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces Semaphore4Xi class objects 
        '''

        
        
        class2print = 'Semaphore4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-Semaphore4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; Semaphore4Xi-acing-by-ace-of-Semaphore4Xi: " + str(Semaphore4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                       
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-Semaphore4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; Semaphore4Xi-aced-by-ace-of-Semaphore4Xi: " + str(Semaphore4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-Semaphore4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of semaphore4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



